using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Net.Sockets;
using System.Net;
using System.IO;

namespace Source
{
    public partial class Normal_File : Form
    {
      
        string ser1;
        string fileDes,fileini;
        int len;
        public Normal_File()
        {
            InitializeComponent();
        }

        private void Normal_File_Load(object sender, EventArgs e)
        {
            
            btnSend.Enabled = false;
            
        }

        private void btnOpen_Click(object sender, EventArgs e)
        {
            txtFilePath.Text = "";
            openFileDialog1.ShowDialog();
            txtFilePath.Text = openFileDialog1.FileName;
            fileDes = openFileDialog1.FileName;
            if (fileDes == "openFileDialog1")
            {
                lblError.Text = "";
                lblError.Text = "Select a File first";
                txtFilePath.Text = "";
                btnSend.Enabled = false ;
            }
            else
            {
                len = fileDes.Length;
                fileini = fileDes.Substring(fileDes.IndexOf("\\") + 1);
                btnSend.Enabled = true;
            }
            
        }
        private void btnSend_Click(object sender, EventArgs e)
        {
            //Buffer();
            pic1.Visible = true;
            Application.DoEvents();
           
                send();
                //pic1.Visible = false;

            
        }
        public void send()
        {
            try
            {
                IPAddress[] ipAddress = Dns.GetHostAddresses("127.0.0.1");
                IPEndPoint ipEnd = new IPEndPoint(ipAddress[0], 5655);
                Socket clientSock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);


                string filePath = "";


                fileDes = fileDes.Replace("\\", "/");
                while (fileDes.IndexOf("/") > -1)
                {
                    filePath += fileDes.Substring(0, fileDes.IndexOf("/") + 1);
                    fileDes = fileDes.Substring(fileDes.IndexOf("/") + 1);
                }


                byte[] fileNameByte = Encoding.ASCII.GetBytes(fileDes);

                lblError.Text = "";
                lblError.Text = "Buffering ...";
                byte[] fileData = File.ReadAllBytes(filePath + fileDes);
                byte[] clientData = new byte[4 + fileNameByte.Length + fileData.Length];
                byte[] fileNameLen = BitConverter.GetBytes(fileNameByte.Length);

                fileNameLen.CopyTo(clientData, 0);
                fileNameByte.CopyTo(clientData, 4);
                fileData.CopyTo(clientData, 4 + fileNameByte.Length);

                lblError.Text = "";
                lblError.Text = "Connection to server ...";
                clientSock.Connect(ipEnd);

                lblError.Text = "";
                lblError.Text = "File sending...";
                clientSock.Send(clientData);

                lblError.Text = "";
                lblError.Text = "Disconnecting...";
                clientSock.Close();

                lblError.Text = "";
                lblError.Text = "File transferred.";
               


            }

            catch (Exception ex)
            {
                if (ex.Message == "A connection attempt failed because the connected party did not properly respond after a period of time, or established connection failed because connected host has failed to respond")
                {
                    lblError.Text = "";
                    lblError.Text = "No Such System Available Try other IP";
                }
                else
                {
                    if (ex.Message == "No connection could be made because the target machine actively refused it")
                    {
                        lblError.Text = "";
                        lblError.Text = "File Sending fail. Because server not running.";
                    }
                    else
                    {
                        lblError.Text = "";
                        lblError.Text = "File Sending fail." + ex.Message;
                    }
                }
            }
        }

        
        
    }
}