using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.IO;



namespace DestCode
{
    public partial class Client : Form
    {
        public Client()
        {
            InitializeComponent();
            DestCode.receivedPath = "";
        }

        private void button1_Click(object sender, EventArgs e)
        {
           
               
           
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label5.Text = DestCode.receivedPath;
            lblres.Text = DestCode.curMsg;
            
        }

        DestCode obj = new DestCode();
        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            
            obj.StartServer();            
        }

        

        private void Form1_Load(object sender, EventArgs e)
        {
            backgroundWorker1.RunWorkerAsync();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog f = new FolderBrowserDialog();
            f.ShowDialog();
            if (f.SelectedPath != "")
            {
                DestCode.receivedPath = f.SelectedPath;
                label5.Text = f.SelectedPath;
            }
            else
            {
                MessageBox.Show("Please Select a File Receiving Path.\r\n Else You Can not Receive the File");
            }
        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            
        }
    }
    //FILE TRANSFER USING C#.NET SOCKET - SERVER
    class DestCode
    {
        IPEndPoint ipEnd;
        Socket sock;
        public DestCode()
        {
           ipEnd = new IPEndPoint(IPAddress.Any, 5656);
           sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
           sock.Bind(ipEnd);
        }
        public static string receivedPath;
        public static string curMsg = "Stopped";
        public  void StartServer()
        {
            try
            {
                curMsg = "Starting...";
                sock.Listen(100);

                curMsg = "Running and waiting to receive file.";
                Socket clientSock = sock.Accept();

                byte[] clientData = new byte[1024 * 5000];
                
                int receivedBytesLen = clientSock.Receive(clientData);
                curMsg = "Receiving data...";

                int fileNameLen = BitConverter.ToInt32(clientData, 0);
                string fileName = Encoding.ASCII.GetString(clientData, 4, fileNameLen);

                BinaryWriter bWrite = new BinaryWriter(File.Open(receivedPath +"/"+ fileName, FileMode.Append)); ;
                bWrite.Write(clientData,4 + fileNameLen, receivedBytesLen - 4 - fileNameLen);
                if (receivedPath == "")
                {
                    MessageBox.Show("No Path was selected to Save the File");
                }
                curMsg = "Saving file...";

                bWrite.Close();
                clientSock.Close();
                curMsg = "File Received ...";

                StartServer();
                
            }
            catch (Exception ex)
            {
                curMsg = "File Receving error.";
            }
        }
    }
}